/*
   Briscola 3.2: Programma di briscola a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define F1  1
#define F2  2
#define F3  3
#define F4  4
#define F5  5
#define F6  6
#define F7  7
#define F8  8
#define F9  9
#define F10 10
#define P1  11
#define P2  12
#define P3  13
#define P4  14
#define P5  15
#define P6  16
#define P7 17
#define P8  18
#define P9  19
#define P10 20
#define C1  21
#define C2  22
#define C3  23
#define C4  24
#define C5  25
#define C6  26
#define C7  27
#define C8  28
#define C9  29
#define C10 30
#define D1  31
#define D2  32
#define D3  33
#define D4  34
#define D5  35
#define D6  36
#define D7  37
#define D8  38
#define D9  39
#define D10 40

#define TN  111 
#define TC  222  
#define TB  333  
#define TBC 444  
#define TBP 555  
#define TP  666  

#define ZF 1001
#define ZP 1011
#define ZC 1021
#define ZD 1031

#define ALLEGRO_STATICLINK
#define WS_MYWIN            (WS_VISIBLE	       | \
                             WS_SYSMENU        | \
                             WS_CAPTION        | \
                             WS_MAXIMIZEBOX    | \
                             WS_MINIMIZEBOX    | \
                             WS_THICKFRAME)

#include <allegro.h>
#include <winalleg.h>
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <COMMCTRL.H>

#include "resource.h"
#include "dimensioni.h"
#include "destro.h"
#include "destro.h"
#include "datc.h"
#include "file.hpp"

void carterandom(int& i,int& carta,int* carteg, int* mcarte);
void ass(int& g1c1, int& g1c2, int& g1c3,int& g2c1,int& g2c2, int& g2c3,int* carteg,int& brs, int& bsm);
int risp(int lv,int cpl, int& c1, int& c2, int& c3,int no21,int no22,int no23,int bsm,int brs,int* fcards1,int* fcards2,int fc1,int fc2,int p1,int p2,int p3,int czPREC,int cpuPREC,int no11,int no12,int no13,int stPREC,int ncard,int* carteg,int punt1,int punt2);
int sc(int lv,int& c1, int& c2, int& c3,int no21,int no22,int no23,int bsm,int brs,int* fcards1,int* fcards2,int fc1,int fc2,int p1,int p2,int p3,int czPREC,int cpuPREC,int no11,int no12,int no13,int stPREC,int ncard,int* carteg,int punt1,int punt2);
void game(int carta1, int carta2, int& p11, int& p22, int& toc,int brs,int bsm,int* fcards1,int* fcards2,int& fc1,int& fc2,int& czPREC,int& cpuPREC,int& stPREC);
void loadcarte();
void newcartaP1(int& g1c1, int& g1c2, int& g1c3,int& g2c1,int& g2c2, int& g2c3,int& carta1,int& carta2,int& ncard,int* carteg);
void newcartaP2(int& g1c1, int& g1c2, int& g1c3,int& g2c1,int& g2c2, int& g2c3,int& carta1,int& carta2,int& ncard,int* carteg);
void disattiva(int ncard, int g1c1,int g1c2,int g1c3,int carta1,int& no11,int& no12,int& no13);
COLORREF green();
COLORREF red();
COLORREF blue();
COLORREF black();
void cartecop();
/*
int vcheck(int s);
void vset(char ch[],int v,HWND hwnd);
int vread(char ch[],HWND hwnd);
int vnameck(int s);
void vsetN(char ch[],int v,HWND hwnd);
int vreadN(char ch[],HWND hwnd);
int vcheckN(int s);
void vnamew(char* ch,char* ch2,HWND hwnd);
void vnamer(char* ch,char* ch2,HWND hwnd);
*/
void endgame(HDC hdc,HDC hdcMem,int* fcards1,int* fcards2,int& fc1,int& fc2,HWND hwnd);
int I_WSA(void) ;
/*void selz(int c1, int c2, int c3,
		  int bsm,int brs,
		  int g1,int g2,int g3,
		  int s1,int s2,int s3,
		  int z1,int z2,int z3,
		  int& cpu,int ss,
		  int cz,int gz,int sz,int zz);
void selzR(int c1, int c2, 
		  int bsm,int brs,
		  int g1,int g2,
		  int s1,int s2,
		  int z1,int z2,
		  int& cpu,int ss,
		  int cz,int gz,int sz,int zz);
int fcfind(int* fcards,int fc,int card);
*/

//void nomexe(char* buf);
void value(int c1,int c2,int c3,int& g1,int& g2,int& g3,int& s1,int& s2,int& s3,int bsm,int& z1,int& z2,int& z3);
//int ckTC(int carta,int* fcards1,int* fcards2,int fc1,int fc2,int bsm,int c1,int c2,int c3);
//int snumcard(int carta,int* fcards1,int* fcards2,int fc1,int fc2,int bsm,int c1,int c2,int c3);
//int ckTCG(int carta,int bsm,int p1,int p2,int p3);
//void CMB(int gn,int sn,int zn,int& cpu,int ncard,int* carteg,int bsm);

//int readNUM(HWND hwnd);
/**/
//void gamelog(int carta1,int carta2,int g1c1,int g1c2,int g1c3,int g2c1,int g2c2,int g2c3,int brs,int bsm,int toc);
//void gamelogstat(int toc,int no11,int no12,int no13,int no21,int no22,int no23,int p11,int p22);
//void errorlogic(int cz,int c1,int c2,int c3,int bsm,int brs,int no21,int no22,int no23,int gamemode,int sz,int s1,int s2,int s3,int zz,int z1,int z2,int z3);
/**/
int vrsn(const char* name);


void CreateCard(int SM, int carta2,int& g2c1,int& g2c2,int& g2c3,int no21,int no22,int no23);
int CheckIP(const char* text);
//int CVer(HWND hwnd,SOCKET s,int SOCKMODE);
//void RecvParam(SOCKET s,int& a,int& b,int& c,int& brs,char* name,int& start,int& typ,char* name1,int& pnt);
//void SendParam(SOCKET s,int a,int b,int c,int brs,char* name1,int start,int pnt);
void ExtMessage(const char* msg,char* ret);
void CreateMessage(const char* msg,char* ret,const char *tipo);
bool ClientParam(HWND hwnd,SOCKET s,int& a,int& b,int& c,int& brs,char* name,int& start,int& typ,int& pnt,int& st,char *name1);
bool ServerParam(HWND hwnd,SOCKET s,int& a,int& b,int& c,int& brs,char* name,int& start,int& typ,int& pnt,int& st,char *name1);
void LocalIP(char* str);

void recvNEWcard(char* s,int carta,int& c1,int& c2,int& c3,int& ncard);
void sendNEWcard(SOCKET s,int carta);
void recvGAMEcard(char* s,int& carta);
void sendGAMEcard(SOCKET s,int carta);

void CleanMSG(char* message);

void ResetCard(int SM,int& g2c1,int& g2c2,int& g2c3);