/*
   Briscola 3.2: Programma di briscola a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "carte.h"

/*
void nomexe(char* buf){

char name[100],*buf2;
get_executable_name(name,100);
strtok(name,"\\");
while((buf2=strtok(NULL,"\\"))!=NULL){
strcpy(buf,buf2);
}

}
*/




void Opz::defaultSet(const char *s){
	Opz::setcarte(0);
	Opz::setcur(0);
	Opz::setio_pc(1);
	Opz::setio_rem(1);
	Opz::setmazzo(3);
	Opz::setnum(5);
	Opz::setnumN(5);
	Opz::setonscreen(1);
	Opz::setontitle(0);
	Opz::setpl1("Giocatore");
	Opz::setpl2("Computer");
	Opz::setsliv(1);
	Opz::setstop(0);
	Opz::settipog(1);
	Opz::settipogN(1);
	Opz::setvelocita(2);
	Opz::setVrsn(s);
}


bool Opz::ckVrsn(const char *s){

if (0==strncmp(s,vrsn,12)) return true;

return false;
}

bool Opz::read(){

char line[40];
FILE *fp=fopen("data\\Opz.ini","r");

if (fp==NULL) return false;

bool r=true;
int c=0;
while (NULL!=fgets(line,35,fp)){ if (!Opz::ck(line)){
                                        	r=false;} 
                                c++; }
fclose(fp);

if (c!=17 && r) MessageBox(NULL,"errore nei parametri","errore",0);

return r;
}

void Opz::write(){

	FILE *fp;

if ((fp=fopen("data\\Opz.ini","w"))==NULL){
	mkdir("data");
    fp=fopen("data\\Opz.ini","w");}

    writeLine(fp,"vrsn",vrsn);
	writeLine(fp,"carte",carte);
	writeLine(fp,"cur",cur);
	writeLine(fp,"io_pc",io_pc);
	writeLine(fp,"io_rem",io_rem);
	writeLine(fp,"mazzo",mazzo);
	writeLine(fp,"num",num);
	writeLine(fp,"numN",numN);
	writeLine(fp,"onscreen",onscreen);
	writeLine(fp,"ontitle",ontitle);
	writeLine(fp,"pl1",pl1);
	writeLine(fp,"pl2",pl2);
	writeLine(fp,"sliv",sliv);
	writeLine(fp,"stop",stop);
	writeLine(fp,"tipog",tipog);
	writeLine(fp,"tipogN",tipogN);
    writeLine(fp,"velocita",velocita);

fclose(fp);
}

bool Opz::ck(char *line){

int e=FindE(line);

if (e==-1) //return false;
{MessageBox(NULL,"parametro errato","errore",0); return false;}

if(ck(line,"vrsn")){
	clean(line,e); 
	Opz::setVrsn(line);
}
else if(ck(line,"carte")){
	clean(line,e);
	Opz::setcarte(atoi(line));
}
else if(ck(line,"cur")){
	clean(line,e); 
	Opz::setcur(atoi(line));
}
else if(ck(line,"io_pc")){
	clean(line,e); 
	Opz::setio_pc(atoi(line));
}
else if(ck(line,"io_rem")){
	clean(line,e);
	Opz::setio_rem(atoi(line));
}
else if(ck(line,"mazzo")){
	clean(line,e); 
	Opz::setmazzo(atoi(line));
}
else if(ck(line,"numN")){
	clean(line,e);
	Opz::setnumN(atoi(line));
}
else if(ck(line,"num")){
	clean(line,e); 
	Opz::setnum(atoi(line));
}
else if(ck(line,"onscreen")){
	clean(line,e); 
	Opz::setonscreen(atoi(line));
}
else if(ck(line,"ontitle")){
	clean(line,e); 
	Opz::setontitle(atoi(line));
}
else if(ck(line,"pl1")){
	clean(line,e); 
	Opz::setpl1(line);
}
else if(ck(line,"pl2")){
	clean(line,e); 
	Opz::setpl2(line);
}
else if(ck(line,"sliv")){
	clean(line,e); 
	Opz::setsliv(atoi(line));
}
else if(ck(line,"stop")){
	clean(line,e); 
	Opz::setstop(atoi(line));
}
else if(ck(line,"tipogN")){
	clean(line,e); 
	Opz::settipogN(atoi(line));
}
else if(ck(line,"tipog")){
	clean(line,e); 
	Opz::settipog(atoi(line));
}
else if(ck(line,"velocita")){
	clean(line,e); 
	Opz::setvelocita(atoi(line));
}
else{MessageBox(NULL,"errore nei parametri","errore",0); return false;}



return true;
}

bool Opz::ck(char *line,const char *par){

	if (0==strncmp(line,par,strlen(par)))
    return true;

return false;
}

void Opz::clean(char *s,int e){
    
	int p=e+1;

	for(unsigned int i=p;i<strlen(s);i++){
	if (s[i]!='\n' && s[i]!='\r') s[i-p]=s[i];
	else s[i-p]='\0';
	}

}

int Opz::FindE(const char* s){
for (unsigned int i=0;i<strlen(s);i++)
if(s[i]=='=') return i;
return -1;
}

void Opz::writeLine(FILE *fp,char *par,int o){
    char ch[40];
	sprintf(ch,"%s=%d\n",par,o);
	fputs(ch,fp);
}

void Opz::writeLine(FILE *fp,char *par,char *o){
    char ch[40];
	sprintf(ch,"%s=%s\n",par,o);
	fputs(ch,fp);
}